SIGINTERRUPT(3)

NAME
siginterrupt - allow signals to interrupt system calls

SYNOPSIS
#include <signal.h>
int
siginterrupt(int sig, int flag);

DESCRIPTION
The siginterrupt() function is used to change the system call restart behavior when a system call is interrupted by the specified signal. If flag is false (0), system calls will be restarted if they are interrupted by the specified signal sig and no data has been transferred yet. System call restart is the default behavior on OpenBSD.

If flag is true (1), the restarting of system calls is disabled. If a system call is interrupted by the specified signal and no data has been transferred, the system call will return -1 with the global variable errno set to EINTR. Interrupted system calls that have started transferring data will return the amount of data actually transferred. System call interrupt is the signal behavior found on BSD systems prior to 4.2BSD as well as most systems based upon AT&T UNIX.

Programs may switch between restartable and interruptible system call operation as often as desired in the execution of a program. Issuing a siginterrupt() call during the execution of a signal handler will cause the new action to take place on the next signal to be caught.

RETURN VALUES
siginterrupt() returns 0 on success or -1 if an invalid signal number has been specified.

SEE ALSO
sigaction(2), sigprocmask(2), sigsuspend(2)

HISTORY
The siginterrupt() function appeared in 4.3BSD.